pub mod de;
pub mod magic;
pub mod ser;
pub mod merge;

pub use de::Deserializer;
pub use de::from_value;
pub use merge::merge;
pub use ser::Serializer;
pub use ser::to_value;

// https://stackoverflow.com/questions/34304593/counting-length-of-repetition-in-macro/34324856
#[macro_export]
//#[allow(unused_macros)]
macro_rules! count__ {
    () => (0usize);
    ( $x:tt $($xs:tt)* ) => (1usize + $crate::count__!($($xs)*));
}

#[macro_export]
macro_rules! rec {
    ( $label:expr $(, $item:expr)* ) => {
        {
            let mut r__ = $crate::value::Value::record($label, $crate::count__!($($item)*));
            $(r__.fields_vec_mut().push($item);)*
            r__.finish().wrap()
        }
    }
}
